package ExamplesFromLecture;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Scanner;
import java.util.TreeSet;
import java.util.Vector;

public class L14 {

	/**
	 * @param args
	 * @throws FileNotFoundException
	 */
	public static void main(String[] args) throws FileNotFoundException {
		// This class is all about elements and how we can store them in data
		// structures

		// Our operating assumption is that all of the elements are of the same
		// type

		// first thing, let us set up some mechanism whereby we get elements
		// that we wish to store in a data structure.
		File theFile = new File("L14data");
		Scanner in = new Scanner(theFile);

		// we could also do this
		// Iterator<String> it = new Scanner(theFile);

		// we want to store the elements of our collection (the first names in
		// the file, one name per line) in a data structure.
		// let's start with one such structure, Vector
		// (we'll use other data structures later)

		// Vector<String> myCollection = new Vector<String>();
		// LinkedList<String> myCollection = new LinkedList<String>();
		ArrayList<String> myCollection = new ArrayList<String>();
		// HashSet<String> myCollection = new HashSet<String>();
		// TreeSet<String> myCollection = new TreeSet<String>();

		// so we need to iterate over the lines of the file and for each line,
		// we add it to our collection
		while (in.hasNext()) {
			// notice that the parameter of the add method in the documentation
			// (control+space) is a String (if we declare Vector<Integer>, then
			// the parameter of add will be an Integer)
			String theElement = in.nextLine();
			boolean theReturn = myCollection.add(theElement);
			System.out.println(theElement + " was added?: " + theReturn);
		}
		// myCollection.add(new Integer(9));

		// now we need a fragment of code that will print out the elements in
		// the collection

		Iterator<String> it = myCollection.iterator();
		while (it.hasNext()) {
			System.out.println(it.next());
		}
		System.out.println("***");

		// BEHOLD the new mechanism for iteration
		// it is available for any class that provides an iterator() method
		for (String s : myCollection) {
			System.out.println(s);
		}
		
		// there is also the old standby
		for (int i = 0; i< myCollection.size() ; i++) {
			// can I obtain elements by their index?
			// only lists provide this
			
		}

	}
}
