package ExamplesFromLecture;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;
import java.util.TreeSet;
import java.util.Vector;

import type.lib.CreditCard;
import type.lib.RewardCard;

public class L16 {

	/**
	 * @param args
	 * @throws FileNotFoundException
	 */
	public static void main(String[] args) throws FileNotFoundException {
		// This app reads lines from a file one by one, parses the tokens on
		// each line and then instantiates a object for each line
		// 
		// Assume each line has three tokens
		// File theFile = new File("L16dataset1");

		// create a collection to hold all of the issued credit cards
		List<CreditCard> theCollection = new ArrayList<CreditCard>();
		Scanner theInput = new Scanner(new File("L16dataset2"));
		while (theInput.hasNext()) {
			String cardType = theInput.next();
			String cardNumber = theInput.next();
			String holderName = theInput.next();
			// assume each line represents a credit that we (the financial
			// institution) wants to issue
			Integer cardNo = Integer.parseInt(cardNumber);
			// cardNo is automatically turned into an int by virtue
			// of autounboxing (see JBA index)
			CreditCard c = null;
			if (cardType.equals("CC")) {
				c = new CreditCard(cardNo, holderName);
			} else if (cardType.equals("RC")) {
				c = new RewardCard(cardNo, holderName);
			}
			theCollection.add(c);
			// for fun, consider the following. will this work?
			// theCollection.add(new CreditCard(cardNo, holderName));
		}
		// let's iterate over the collection and invoke toString on each
		for (CreditCard c : theCollection) {
			// this demonstrates polymorphism
			// why? because "c" is two things at once
			// 1. at compile time, c is a CreditCard (in all cases - even when
			// the element is a reward card)
			// 2. at run time, c is a RewardCard in some cases

			// poly+morphism. poly=many, morph=shape
			// an object can have two types at once - one type at compile time
			// and another type at run time.
			// c is polymorphic
			// But they are not really two completely different types.
			// the runtime type, if different, can only ever be a child of the
			// compile time type

			// 4 + 5
			// instanceof is an inifx operator, just like "+" or "=" is
			boolean isChildClass = c instanceof RewardCard;
			System.out.println(isChildClass);
			System.out.println(c.toString());
		}

	}
}
